//=============================================================================
//
// file :        Guntiming.h
//
// description : Include for the Guntiming class.
//
// project :	preinjector timing
//
// $Author: giulio $
//
// $Revision: 1.2 $
//
// $Log: Guntiming.h,v $
// Revision 1.2  2020-03-11 11:21:11  giulio
// Moved from PPC to x64
//
// Revision 1.1.1.1  2014-12-11 14:05:08  zambonl
// Prima versione
//
// Revision 1.1.1.1  2014-11-11 10:00:36  zambonl
// Prima versione
//
// Revision 1.1.1.1  2013-08-06 08:24:53  zambonl
// Prima versione
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _GUNTIMING_H
#define _GUNTIMING_H

#include <tango.h>
#include <sys/time.h>
#include <time.h>

//using namespace Tango;

#define GUNTIMING_STATE_TOUT 500000 /* usec. */

/**
 * @author	$Author: giulio $
 * @version	$Revision: 1.2 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace Guntiming_ns
{

/**
 * Class Description:
 * Timing system for the preinjector modulators
 */

/*
 *	Device States Description:
 */


class Guntiming: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------
	char tmBuffer[80];
	void timestamp(); 


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevDouble	*attr_FilCur_read;
		Tango::DevDouble	attr_FilCur_write;
		Tango::DevDouble	*attr_FilVoltage_read;
		Tango::DevDouble	*attr_DriverCur_read;
		Tango::DevDouble	*attr_DriverVoltage_read;
		Tango::DevDouble	*attr_GridVoltage_read;
		Tango::DevDouble	attr_GridVoltage_write;
		Tango::DevDouble	*attr_Mode_read;
		Tango::DevDouble	attr_Mode_write;
		Tango::DevDouble	*attr_PolVoltage_read;
		Tango::DevDouble	*attr_Temperature_read;
		Tango::DevDouble	*attr_BunchLength_read;
		Tango::DevDouble	attr_BunchLength_write;
		Tango::DevDouble	*attr_FilCurset_read;
		Tango::DevBoolean	*attr_StateFlags_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	
 */
	string	IP;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Guntiming(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	Guntiming(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	Guntiming(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~Guntiming() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name Guntiming methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for FilCur acquisition result.
 */
	virtual void read_FilCur(Tango::Attribute &attr);
/**
 *	Write FilCur attribute values to hardware.
 */
	virtual void write_FilCur(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for FilVoltage acquisition result.
 */
	virtual void read_FilVoltage(Tango::Attribute &attr);
/**
 *	Extract real attribute values for DriverCur acquisition result.
 */
	virtual void read_DriverCur(Tango::Attribute &attr);
/**
 *	Extract real attribute values for DriverVoltage acquisition result.
 */
	virtual void read_DriverVoltage(Tango::Attribute &attr);
/**
 *	Extract real attribute values for GridVoltage acquisition result.
 */
	virtual void read_GridVoltage(Tango::Attribute &attr);
/**
 *	Write GridVoltage attribute values to hardware.
 */
	virtual void write_GridVoltage(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for Mode acquisition result.
 */
	virtual void read_Mode(Tango::Attribute &attr);
/**
 *	Write Mode attribute values to hardware.
 */
	virtual void write_Mode(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for PolVoltage acquisition result.
 */
	virtual void read_PolVoltage(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Temperature acquisition result.
 */
	virtual void read_Temperature(Tango::Attribute &attr);
/**
 *	Extract real attribute values for BunchLength acquisition result.
 */
	virtual void read_BunchLength(Tango::Attribute &attr);
/**
 *	Write BunchLength attribute values to hardware.
 */
	virtual void write_BunchLength(Tango::WAttribute &attr);
/**
 *	Extract real attribute values for FilCurset acquisition result.
 */
	virtual void read_FilCurset(Tango::Attribute &attr);
/**
 *	Extract real attribute values for StateFlags acquisition result.
 */
	virtual void read_StateFlags(Tango::Attribute &attr);
/**
 *	Read/Write allowed for FilCur attribute.
 */
	virtual bool is_FilCur_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FilVoltage attribute.
 */
	virtual bool is_FilVoltage_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DriverVoltage attribute.
 */
	virtual bool is_DriverVoltage_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for DriverCur attribute.
 */
	virtual bool is_DriverCur_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for GridVoltage attribute.
 */
	virtual bool is_GridVoltage_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Mode attribute.
 */
	virtual bool is_Mode_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for PolVoltage attribute.
 */
	virtual bool is_PolVoltage_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Temperature attribute.
 */
	virtual bool is_Temperature_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for BunchLength attribute.
 */
	virtual bool is_BunchLength_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for FilCurset attribute.
 */
	virtual bool is_FilCurset_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for StateFlags attribute.
 */
	virtual bool is_StateFlags_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for Raw command.
 */
	virtual bool is_Raw_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Stinit command.
 */
	virtual bool is_Stinit_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for Restart command.
 */
	virtual bool is_Restart_allowed(const CORBA::Any &any);
/**
 * Send raw command
 *	@exception DevFailed
 */
	Tango::DevVarStringArray	*raw(Tango::DevString);
	// Tango::DevString raw(Tango::DevString);
/**
 * 
 *	@exception DevFailed
 */
	void	stinit();
/**
 * Reset Lantronix via cURL
 *	@exception DevFailed
 */
	void	restart();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	Tango::DevVarBooleanArray datab;	
	Tango::DevBoolean *attr_ab_rd;
	struct timeval last_state_time, alarm_time;
	bool last_alarm;	
	void set_DevStat();
	Tango::DeviceProxy *devoptpdelay;
	Tango::DeviceProxy *devhv;
	double attr_d_rd;
	bool attr_b_rd;
	// Tango::DevLong optpdelay_status;	/* bit 0-3: enable MT counters */
	int32_t optpdelay_status;
	                        /* bit 6,7: interlocks */
			
};

}	// namespace_ns

#endif	// _GUNTIMING_H
